﻿/*
-- t1 は GUI で作成
DROP TABLE t1
CREATE TABLE t1
(  a int IDENTITY(1, 1) PRIMARY KEY
  ,b int
  ,c varchar(200)
  ,d datetime )
*/

CREATE TABLE t1_2
(  a int IDENTITY(1, 1) PRIMARY KEY
  ,b int
  ,c varchar(200)
  ,d datetime )



/*
 
*/

-- クラスター化インデックスを作成していないテーブル
CREATE TABLE t1_3 ( a int, b int )

-- V12 では大丈夫
INSERT INTO t1_3 VALUES(1, 1)

SELECT * FROM t1_3


sp_help 't1'


INSERT INTO t1 VALUES(111, 'AAA', '2015/01/07')

-- 日本語データの追加
INSERT INTO t1 VALUES(222, 'テスト１', '2015/01/07')
INSERT INTO t1 VALUES(333, '漢字テスト', '2015/01/07')

SELECT * FROM t1


/*
-- 照合順序を指定しないでデータベースを作成
CREATE DATABASE AzureDB3
( EDITION = 'BASIC' )

SELECT * FROM sys.databases
*/
CREATE TABLE test1
(  a int IDENTITY(1, 1) PRIMARY KEY
  ,b varchar(200) )

INSERT INTO test1 VALUES('AAA')
INSERT INTO test1 VALUES('テスト１')
INSERT INTO test1 VALUES('漢字テスト')

SELECT * FROM test1

-- nvarchar で N プレフィックスを付けて INSERT を実行
CREATE TABLE test2
(  a int IDENTITY(1, 1) PRIMARY KEY
  ,b nvarchar(200) )

INSERT INTO test2 VALUES(N'AAA')
INSERT INTO test2 VALUES(N'テスト１')
INSERT INTO test2 VALUES(N'漢字テスト')

SELECT * FROM test2

DROP TABLE test1
DROP TABLE test2



-- 日付時刻データの確認（UTC）

INSERT INTO t1 VALUES(444, 'BBB', GETDATE())
INSERT INTO t1 VALUES(555, 'BBB', SYSDATETIME())
INSERT INTO t1 VALUES(666, 'BBB', SYSUTCDATETIME())

SELECT * FROM t1


-- 日本標準時（UTC +9）の取得

INSERT INTO t1 VALUES(777, 'BBB', DATEADD(hour, 9, SYSUTCDATETIME()) )

SELECT * FROM t1



UPDATE t1 SET b = 999 WHERE a = 4

SELECT * FROM t1


DELETE FROM t1 WHERE a = 4

SELECT * FROM t1


CREATE VIEW view1
AS
SELECT * FROM t1 WHERE a <= 3
go


SELECT * FROM view1


CREATE PROC proc1
@maxVal int
AS
DECLARE @i int = 1
WHILE @i <= @maxVal
BEGIN
      INSERT INTO t1 VALUES(@i, 'CCC', GETDATE())
      SET @i += 1
END


-- 1万件のデータの追加
EXEC proc1 @maxVal = 10000

SELECT * FROM t1



SELECT * FROM t1 WHERE b = 9999


CREATE NONCLUSTERED INDEX idx_b
 ON t1(b)


SELECT * FROM t1 WHERE b = 9999



ALTER INDEX idx_b
 ON t1 REBUILD

-- オンラインでのインデックスの再構築（V11 でも利用可能）
ALTER INDEX idx_b
 ON t1 REBUILD WITH (ONLINE = ON)

-- インデックスの再構成（V12 から利用可能）
ALTER INDEX idx_b
 ON t1 REORGANIZE

-- 断片化状況のチェック（V11 でも利用可能）
-- t1 テーブルをチェック
SELECT OBJECT_NAME(object_id), index_id, avg_fragmentation_in_percent
      ,index_level, page_count, record_count
	  ,avg_page_space_used_in_percent, *
FROM
 sys.dm_db_index_physical_stats(DB_ID(), OBJECT_ID('t1'), NULL, NULL, 'DETAILED')


-- FILLFACTOR は V12 から利用可能
ALTER INDEX idx_b
 ON t1 REBUILD WITH (FILLFACTOR = 80)

-- PAD_INDEX も V12 から利用可能
ALTER INDEX idx_b
 ON t1 REBUILD WITH (FILLFACTOR = 80, PAD_INDEX = ON)


