﻿
-- パーティション関数の作成
CREATE PARTITION FUNCTION pFunc1 (datetime)
 AS RANGE RIGHT FOR
  VALUES ('2013/01/01', '2014/01/01', '2015/01/01')

-- パーティション構成の作成
CREATE PARTITION SCHEME pScheme1
 AS PARTITION pFunc1
  ALL TO ([PRIMARY])

-- パーティション テーブルの作成
CREATE TABLE ptest1
(  colA int IDENTITY(1,1) NOT NULL
  ,colB datetime
) ON pScheme1(colB)


-- データを 6件 INSERT
INSERT INTO ptest1
  VALUES ('2012/12/31')
        ,('2013/01/01')
        ,('2013/12/31')
        ,('2014/01/01')
        ,('2014/12/31')
        ,('2015/01/01')

-- どのパーティションに格納されたか確認
SELECT *, $PARTITION.pFunc1(colB) As [パーティション番号]
FROM ptest1


-- パーティション インデックスの作成
CREATE CLUSTERED INDEX index_colB
  ON ptest1 (colB)
    ON pScheme1 (colB)

-- Clustered Index Seek
SELECT * FROM ptest1
  WHERE colB = '2014/12/31'


-- パーティション2 を再構築
ALTER INDEX index_colB
  ON ptest1
    REBUILD PARTITION = 2

-- パーティション3 を再構成
ALTER INDEX index_colB
  ON ptest1
    REORGANIZE PARTITION = 3

-- パーティション1 を行圧縮
ALTER TABLE ptest1
 REBUILD PARTITION = 1
  WITH ( DATA_COMPRESSION = ROW )

